#include <Keypad.h>  // include keypad
#include <Servo.h>
Servo Servo12, Servo13;
const byte ROWS = 4; //four rows
const byte COLS = 4;//three columns

char keys[ROWS][COLS] = // this shows the keypad elements in rows and columns
{
{'1', '2', '3', 'A'},
  {'4', '5', '6', 'B'},
  {'7', '8', '9', 'C'},
  {'*', '0', '#', 'D'}
};

byte rowPins[ROWS] = {9, 8, 7, 6}; //connect to the row pinouts of the keypad
byte colPins[COLS] = {5, 4, 3, 2}; //connect to the column pinouts of the keypad

Keypad keypad = Keypad( makeKeymap(keys), rowPins, colPins, ROWS, COLS ); // makes a keypad with character map in with pins atteched to row keys and column keys with number of rows and columns
const String password = "789"; // change your password here
String input_password;
int buzzerFlag=0;
int buzzerCount=0;
// the setup function runs once when you press reset or power the board
void setup() 
{
  Serial.begin(9600); // start Serial communication
  input_password.reserve(32); // maximum input characters is 33, change if needed
  pinMode(2, INPUT); //Photo Sensor
  pinMode(10,INPUT); //LDR Sensor
  pinMode(11, OUTPUT);//Buzzer Pin
  Servo12.attach(12);
  Servo13.attach(13);
  delay(500);
  Servo12.write(90); //keep doors open
  Servo13.write(0); //keep vault door closed
}

// the loop function runs over and over again forever
void loop() 
{
  if (digitalRead(2)==LOW) //Photo sensor obstacle detected
      Servo13.write(90);
  if (digitalRead(10)==HIGH) //LDR obstacle detected
  {
    buzzerFlag=1;
    Servo13.write(90);
  }
  if(buzzerFlag)
  {
    if(buzzerCount%2)
      digitalWrite(11, HIGH);    // Buzzer ON
    else
      digitalWrite(11, LOW);    // Buzzer OFF
    buzzerCount++;
    if(buzzerCount>=100)
    {
      buzzerFlag=0;
      buzzerCount=0;
      digitalWrite(11, LOW);    // Buzzer OFF
    }
  }
      
  char key = keypad.getKey(); // checks if any key is pressed or not?

  if (key)
  { //if key is pressed
    Serial.println(key); // print key
    if(key == '*') 
      input_password = ""; // clear input password
    else if(key == '#') 
    {
      if(password == input_password) 
      {
        Serial.println("password is correct");
        Servo12.write(0);
      }
      else 
      {
        Serial.println("password is incorrect, try again");
        buzzerFlag=1;
        Servo13.write(90);
        input_password = ""; // clear input password
      }
    } 
    else 
      input_password += key; // append new character to input password string
  }
  delay(100);

}
